// ImageDlg.cpp : Cve[V t@C
//

#include "headers.h"
#include "XDISKWIN2.h"
#include "XDISKWIN2Doc.h"
#include "XDISKWIN2View.h"
#include "ImageDlg.h"
#include "xdisk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImageDlg _CAO


CImageDlg::CImageDlg(CXDISKWIN2View* pParent /*=NULL*/)
	: CDialog(CImageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CImageDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT

	m_parent = NULL;
	if (pParent) {
		m_parent   = pParent;
	}
}


void CImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CImageDlg)
	DDX_Control(pDX, IDC_LIST, m_list);
	DDX_Control(pDX, IDOK, m_ok);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CImageDlg, CDialog)
	//{{AFX_MSG_MAP(CImageDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST, OnDblclkList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImageDlg bZ[W nh

BOOL CImageDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if (!m_parent) return TRUE;

	if (m_parent->m_mode != 3) {
		m_ok.EnableWindow(FALSE);
	}

	int			i;
	LV_ITEM		item;
	LV_COLUMN	col;
	char		*szColName[] = { "", "ި", "ø", "ި" };
	int			ColWidth[] = { 20, 140, 50, 50 };
	char		*szMediaName[] = { "2D", "2DD", "2HD", "???" };
	char		*szProtectStat[] = { "", "ON" , "???"};
	struct ImageHeader
	{
		char title[17];
		uint8 reserved[9];
		uint8 readonly;
		uint8 disktype;
		uint32 disksize;
		uint32 trackptr[164];
	} image;

	col.mask = LVCF_TEXT | LVCF_WIDTH;
	for (i = 0; i < 4; i++) {
		col.pszText = szColName[i];
		col.cx = ColWidth[i];
		m_list.InsertColumn(i, &col);
	}
	
	m_parent->m_file.Seek(0, FileIO::end);
	int dis = m_parent->m_file.Tellp();

	m_parent->m_file.SetLogicalOrigin(0);
	int pos = 0;
	int index = 0;

	item.mask = LVIF_TEXT;
	char szBuf[17];
	ZeroMemory(szBuf, 17);
	while (pos < dis)
	{
		m_parent->m_file.Seek(pos, FileIO::begin);
		m_parent->m_file.Read(&image, sizeof(image));
		uint32 size = image.disksize;
		if (size == 0xdeadd13c || size == 0 || size > 4 * 1024 * 1024)
			break;
		pos += size;

		item.iItem = index;
		item.iSubItem = 0;
		wsprintf(szBuf, "%3d", index + 1);
		item.pszText = szBuf;
		if (m_list.InsertItem(&item) == -1)
			continue;

		item.iSubItem = 1;
		strncpy(szBuf, image.title, 16);
		m_list.SetItem(&item);

		uint8 readonly = image.readonly / 16;
		item.iSubItem = 2;
		item.pszText = szProtectStat[readonly > 1 ? 2 : readonly];
		m_list.SetItem(&item);

		uint8 disktype = image.disktype / 16;
		item.iSubItem = 3;
		item.pszText = szMediaName[disktype > 2 ? 3 : disktype];
		m_list.SetItem(&item);
		index++;
	}
	if (m_parent->m_temp) {
		m_list.SetItemState(m_parent->m_temp - 1, LVIS_SELECTED, LVIS_SELECTED);
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CImageDlg::OnOK() 
{
	if (m_parent) {
		m_parent->m_temp = GetSelectedPos();
	}
	CDialog::OnOK();
}

void CImageDlg::OnDblclkList(NMHDR* pNMHDR, LRESULT* pResult) 
{	
	*pResult = 0;

	if (m_parent) {
		m_parent->m_temp = GetSelectedPos();
		if (m_parent->m_mode != 3 || !m_parent->m_temp) 
			return;
		CDialog::OnOK();
	}
}

int CImageDlg::GetSelectedPos() 
{
	int i = 0;

	for (i = 0; i < m_list.GetItemCount(); i++) {
		if (m_list.GetItemState(i, LVIS_SELECTED)) {
			break;
		}
	}
	if (i == m_list.GetItemCount()) {
		return 0;
	}
	return i + 1;
}
