// SetupDlg.cpp : Cve[V t@C
//

#include "headers.h"
#include "XDISKWIN2.h"
#include "XDISKWIN2Doc.h"
#include "XDISKWIN2View.h"
#include "SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg _CAO


CSetupDlg::CSetupDlg(CXDISKWIN2View* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
	, m_comport(0)
{
	//{{AFX_DATA_INIT(CSetupDlg)
	m_fast = FALSE;
	m_verbose = FALSE;
	m_baudrate = -1;
	m_comport = -1;
	//}}AFX_DATA_INIT

	m_parent = NULL;
	if (pParent) {
		m_parent   = pParent;
		m_baudrate = m_parent->m_baudrate;
		m_comport  = m_parent->m_port + 1;
		m_fast     = m_parent->m_fast;
		m_verbose  = m_parent->m_verbose;
	}
}


void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupDlg)
	DDX_Check(pDX, IDC_CHK_FAST, m_fast);
	DDX_Check(pDX, IDC_CHK_VERBOSE, m_verbose);
	DDX_CBIndex(pDX, IDC_CMB_BAUDRATE, m_baudrate);
	DDX_Text(pDX, IDC_EDT_COM_PORT, m_comport);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_COMPORT, &CSetupDlg::OnDeltaposSpnComport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg bZ[W nh

void CSetupDlg::OnOK() 
{
	if (m_parent) {
		if (!UpdateData(TRUE))
			return;
		if (m_comport < COM_MIN || m_comport > COM_MAX)
		{
			char buf[256];
			sprintf(buf, "ʐM|[gɂ%d`%dw肵Ă", COM_MIN, COM_MAX);
			MessageBox(buf);
			return;
		}
		m_parent->m_baudrate = m_baudrate;
		m_parent->m_port     = m_comport - 1;
		m_parent->m_fast     = m_fast;
		m_parent->m_verbose  = m_verbose;
	}
	
	CDialog::OnOK();
}

void CSetupDlg::OnDeltaposSpnComport(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	UpdateData(TRUE);

	m_comport -= pNMUpDown->iDelta;
	if (m_comport < COM_MIN) m_comport = COM_MIN;
	if (m_comport > COM_MAX) m_comport = COM_MAX;

	UpdateData(FALSE);

	*pResult = 0;
}
